using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Object = UnityEngine.Object;
using Random = UnityEngine.Random;

namespace CheesyFX
{
    public class TouchZone : BodyRegion
    {
        public TouchCollisionListener touchCollisionListener;
        // public CumRegion cumRegion;
        public List<Atom> atomsToCollideWith = new List<Atom>();
        public List<Action> onWatchActions = new List<Action>();
        
        public JSONStorableBool slapEnabled;
        public GameObject slapAudioObject;
        public AudioSource slapAudioSource;
        public float slapIntensity;
        public IEnumerator slap;
        private System.Random rdn = new System.Random();

        public TouchZone(string region) : base(region){
            touchCollisionListener = new TouchCollisionListener(this);
            ToggleSlapAudioObject(true);
        }
        
        public void ToggleSlapAudioObject(bool enabled){
            if(enabled){
                slapAudioObject = new GameObject();
                slapAudioSource = slapAudioObject.AddComponent<AudioSource>();
                slapAudioSource.spatialBlend = 1f;
                slapAudioSource.spatialize = true;
            }
            else Object.Destroy(slapAudioObject);
        }

        public void Slap(float intensity, TouchZone touchZone, Collision collision, bool doVocals, bool doMoan)
        {
            if(intensity <= slapIntensity) return;
            slapIntensity = intensity;
            if (slap == null) slap = DeferrredSlap(touchZone, collision , doVocals, doMoan).Start();
        }
        
        private IEnumerator DeferrredSlap(TouchZone touchZone, Collision collision, bool doVacals, bool doMoan)
        {
            // if (!slapVocalsEnabled) yield break;
            AudioClip clip = SlapMe.slapLibrary.GetRandomClip();

            yield return new WaitForSeconds(.1f);
            // slapIntensity.Print();
            // slapIntensity *= touchZone.slapVolumeFactor.val;
            float volumeFactor = slapIntensity * slapIntensity*.02f * SlapMe.slapVolume.val;
            slapAudioSource.pitch = Mathf.Lerp(.7f, 1.5f* slapPitchFactor.val, slapIntensity*.166f);
            // slapAudioSource.pitch = 1f;
            // slapAudioSource.pitch.Print();
            slapAudioSource.PlayOneShot(clip, volumeFactor);
            if(slapIntensity > 1f){
                // slapIntensity.Print();
                if (ReadMyLips.blinkTimeout <= 0f && Random.Range(0f, slapIntensity) > 3f)
                {
                    ReadMyLips.eyelidBehavior.Blink();
                    ReadMyLips.blinkTimeout = 1f;
                }
                if(ReadMyLips.singleton.enabled) ReadMyLips.Stimulate(slapIntensity);
                if(doMoan) ReadMyLips.PlayMoan();
                // var prompt = "{{user}} slaps {{char}}'s "+ touchZone.name +" with a " + collision.rigidbody.GetAtom().type+
                //     " with an intensity of " + slapIntensity.ToString();
                // prompt.Print();
            }
            // touchZone.bodyManager.arousal.arousal.val += touchZone.topParent.slapArousalRate.val * slapIntensity;
            // if(doVocals && slapVocalsEnabled && touchZone.slapVocalReactionEnabled.val && !FillMeUp.throat.isPenetrated){
            // 	slapIntensity *= touchZone.slapSensitivity.val;
            // 	if(touchZone.slapReactionTimer <= 0f || slapIntensity > touchZone.lastSlapIntensity+4f){
            // 		if(slapIntensity > 9) slapIntensity = 9f;
            // 		ClipLibrary cl;
            // 		if(touchZone.onSlapLibraries.TryGetValue((int) slapIntensity, out cl)){
            // 			cl.PlayRandom(slapIntensity > 3);
            // 		}
            // 		else AudioImporter.globalOnSlapClips[(int) slapIntensity].PlayRandom(slapIntensity > 3);
            // 		touchZone.slapReactionTimer = touchZone.slapReactionTimeout.val;
            // 		touchZone.lastSlapIntensity = slapIntensity;
            // 	}
            // }
            slapIntensity = 0f;
            slap = null;
        }

        public void Destroy()
        {
            touchCollisionListener.Destroy();
            Object.Destroy(slapAudioObject);
        }

        // public void GetCumRegion()
        // {
        //     foreach (var prnt in parents)
        //     {
        //         if (bodyManager.cumRegions.TryGetValue(prnt.name, out cumRegion))
        //         {
        //             // prnt.name.Print();
        //             return;
        //         }
        //     }
        // }
    }
}